function [m] = ywl2mat(str)
//		Convert a string into MY :) convention back to the matrix.
//		Used for parameter passing between Scilab and Tk/Tcl. 

	v = strsplit(str, '|')
	ty = convstr(v(1), 'l')			// Data type
	nr = eval(v(2))				// # Columns
	nc = eval(v(3))				// # Rows
	if nr==0 & nc==0 then			// Special case of empty matrix
		m = []
		return
	end
	contents = v(4:size(v,'*'))
//		Bottle neck: it is time-consuming for evaluating all the
//		elements. Need a more efficient way than 'eval'.
//		Time for evalulating the content is 5-6 times more than time
//		used by 'strsplit' (which is slow by itself too :( ).
	select ty
		case 'con' then m=eval(contents)
		case 'boo' then m=eval(contents)>0
		case 'int1' then m=iconvert(eval(contents),1)
		case 'int2' then m=iconvert(eval(contents),1)
		case 'int4' then m=iconvert(eval(contents),4)
		case 'int11' then m=iconvert(eval(contents),11)
		case 'int12' then m=iconvert(eval(contents),12)
		case 'int14' then m=iconvert(eval(contents),14)
		case 'str' then m=contents
		else error('Error in ywl2mat: Data type not supported')
	end
	m=matrix(m,nr,nc)
			
